#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q, l, r, cnt = 0, x, y;
    int a[20002];
    string s;
    cin >> s;
    for(int i = 1; i < s.size(); i++)
    {
        if(s[i]<s[i-1])
        {
            a[cnt] = i-1;
            cnt++;
        }
    }
    cin >> q;
    for(int i = 0; i < q; i++)
    {
        cin >> l >> r;
        l--;
        r--;
        x = 0;
        while(a[x] < l)
            x++;
        y = cnt - 1;
        while(a[y] >= r)
            y--;
        cout << y - x + 2 << '\n';
    }
    return 0;
}
